(function() {
	// BGMボリューム値
	var volumeBGM = 50;
	// SEボリューム値
	var volumeSE = 50;
	//サウンドデータロード完了フラグ
	var loadSoundFlag = false;

	/*
	 * サウンドデータをまとめて読み込む
	 */
	loadSound = function() {
		//BGMを読み込み
		var bgmList = [
			{track:0, src:"gamesound/bgm1.mp3"},
			{track:1, src:"gamesound/bgm2.mp3"},
			{track:2, src:"gamesound/bgm3.mp3"},
			{track:3, src:"gamesound/bgm4.mp3"}
		];
		applican.gamesound.loadBGM(bgmList, loadBGMSuccess, loadBGMError);
	};

	/*
	 * SEサウンドデータをまとめて読み込む
	 */
	function loadBGMSuccess() {
		var dump = "BGMサウンドデータをロードしました。\n";
		document.getElementById("dumpAreaGameSound").value = dump;
		//SEを読み込み
		var seList = [
			{track:0,  src:"gamesound/se1.wav"},
			{track:1,  src:"gamesound/se2.wav"},
			{track:2,  src:"gamesound/se3.wav"},
			{track:3,  src:"gamesound/se4.wav"},
			{track:4,  src:"gamesound/se5.wav"},
			{track:5,  src:"gamesound/se6.wav"},
			{track:6,  src:"gamesound/se7.wav"},
			{track:7,  src:"gamesound/se8.wav"},
			{track:8,  src:"gamesound/se9.wav"},
			{track:9,  src:"gamesound/se10.wav"},
			{track:10, src:"gamesound/se11.wav"},
			{track:11, src:"gamesound/se12.wav"}
		];
		applican.gamesound.loadSE(seList, loadSESuccess, loadSEError);
	}

	/*
	 * BGMサウンドデータをロード失敗時のcallback処理
	 */
	function loadBGMError(err) {
		var dump = "BGMサウンドデータのロードに失敗しました。\n";
		dump += "code:" + err.code + "\n";
		document.getElementById("dumpAreaGameSound").value = dump;
	}

	/*
	 * SEサウンドデータをロード成功時のcallback処理
	 */
	function loadSESuccess() {
		var dump = "SEサウンドデータをロードしました。\n";
		document.getElementById("dumpAreaGameSound").value += dump;

		//サウンドデータロード済み
		loadSoundFlag = true;
	}

	/*
	 * SEサウンドデータをロード失敗時のcallback処理
	 */
	function loadSEError(err) {
		var dump = "SEサウンドデータのロードに失敗しました。\n";
		dump += "code:" + err.code + "\n";
		document.getElementById("dumpAreaGameSound").value += dump;
	}

	/*
	 * BGM再生
	 */
	playBGM = function() {
		if(!loadSoundFlag) {
			alert("サウンドデータを読み込んでください。");
			return;
		}

		var track = document.getElementById("bgmTrackList").value;
		var options = {};
		options.track = track;
		options.loop = true;
		applican.gamesound.playBGM(options);
	};

	/*
	 * BGM一時停止
	 */
	pauseBGM = function() {
		var track = document.getElementById("bgmTrackList").value;
		applican.gamesound.pauseBGM(track);
	};

	/*
	 * BGM終了
	 */
	stopBGM = function() {
		var track = document.getElementById("bgmTrackList").value;
		applican.gamesound.stopBGM(track);
	};

	/*
	 * BGMボリューム
	 */
	function setBGMVolume(volume) {
		var track = document.getElementById("bgmTrackList").value;
		document.getElementById("bgmVolumeNum").style.width = volume + "%";
		applican.gamesound.setBGMVolume(track, volume);
	}

	/*
	 * SE再生
	 */
	playSE = function(track) {
		if(!loadSoundFlag) {
			alert("サウンドデータを読み込んでください。");
			return;
		}
		applican.gamesound.playSE(track);
	};

	/*
	 * SE終了
	 */
	stopSE = function(track) {
		applican.gamesound.stopSE(track);
	};

	/*
	 * SEボリューム
	 */
	function setSEVolume(track, volume) {
		document.getElementById("seVolumeNum").style.width = volume + "%";
		applican.gamesound.setSEVolume(track, volume);
	}

	/*
	 * 全てのサウンドを停止
	 */
	stopSound = function() {
		// BGMサウンドを停止
		applican.gamesound.stopAllBGM();
		// SEサウンドを停止
		applican.gamesound.stopAllSE();

		var dump = "全てのサウンドを停止しました。\n";
		document.getElementById("dumpAreaGameSound").value = dump;
	};

	/*
	 * サウンドデータを解放する
	 */
	releaseSound = function() {
		applican.gamesound.releaseAllBGM();
		applican.gamesound.releaseAllSE();

		var dump = "サウンドデータをメモリから解放しました。\n";
		document.getElementById("dumpAreaGameSound").value = dump;
		loadSoundFlag = false;
	};

	/*
	 * BGM音量－
	 */
	bgmVolumeDown = function() {
		volumeBGM = volumeBGM - 10;
		if(volumeBGM < 0) {
			volumeBGM = 0;
		}
		setBGMVolume(volumeBGM);
	};

	/*
	 * BGM音量+
	 */
	bgmVolumeUp = function() {
		volumeBGM = volumeBGM + 10;
		if(volumeBGM > 100) {
			volumeBGM = 100;
		}
		setBGMVolume(volumeBGM);
	};

	/*
	 * SE音量－
	 */
	seVolumeDown = function() {
		volumeSE = volumeSE - 10;
		if(volumeSE < 0) {
			volumeSE = 0;
		}
		setSEVolume(0, volumeSE);
	};

	/*
	 * SE音量+
	 */
	seVolumeUp = function() {
		volumeSE = volumeSE + 10;
		if(volumeSE > 100) {
			volumeSE = 100;
		}
		setSEVolume(0, volumeSE);
	};

	/********************* イベント登録 *********************/
	document.addEventListener("deviceready", function() {
		// 「サウンドデータの一括読み込み<」ボタン押下処理
		document.getElementById("btnLoadSound").addEventListener("touchend", loadSound, false);
		// 「全てのサウンドを停止」ボタン押下処理
		document.getElementById("btnStopSound").addEventListener("touchend", stopSound, false);
		// 「全てのサウンドを解放」ボタン押下処理
		document.getElementById("btnReleaseSound").addEventListener("touchend", releaseSound, false);
		// 「BGM再生」ボタン押下処理
		document.getElementById("btnPlayBGM").addEventListener("touchend", playBGM, false);
		// 「BGM再生中止」ボタン押下処理
		document.getElementById("btnPauseBGM").addEventListener("touchend", pauseBGM, false);
		// 「BGM再生停止」ボタン押下処理
		document.getElementById("btnStopBGM").addEventListener("touchend", stopBGM, false);
		// 「BGM音量-」ボタン押下処理
		document.getElementById("btnBgmVolumeDown").addEventListener("touchend", bgmVolumeDown, false);
		// 「BGM音量+」ボタン押下処理
		document.getElementById("btnBgmVolumeUp").addEventListener("touchend", bgmVolumeUp, false);
		// 「SE音量-」ボタン押下処理
		document.getElementById("btnSeVolumeDown").addEventListener("touchend", seVolumeDown, false);
		// 「SE音量+」ボタン押下処理
		document.getElementById("btnSeVolumeUp").addEventListener("touchend", seVolumeUp, false);
		// 「SE1終了」ボタン押下処理
		document.getElementById("btnStopSE").addEventListener("touchend", function () {
			stopSE(0);
		}, false);
		// 「SE1再生」～「SE12再生」ボタン押下処理
		var play = function (idx) {
			document.getElementById("btnPlaySE" + idx).addEventListener("touchend", function () {
				playSE(idx);
			}, false);
		};
		for (var i = 0; i <= 11; i++) {
			play(i);
		}
	});

})();
